/* Motor Paso a Paso ajustado a grados y velocida.
 by: Nohely Isabel De La Cruz Vazquez Residencia Profesional
   

Arduino    Driver ULN200
  8          IN1
  9          IN2
  10         IN3
  11         IN4
  
*/


int retardo=5;          // Tiempo de retardo en milisegundos (Velocidad del Motor)
int dato_rx;            // valor recibido en grados
int numero_pasos = 0;   // Valor en grados donde se encuentra el motor
String leeCadena;       // Almacena la cadena de datos recibida
int motorSpeed = 0;     //variable to set stepper speed
int potPin = 2;   //potentiometer connected to A2
int potValue = 0;   //variable to read A0 input
 const int sensorLuz = A1;
 int luminosidadMedia;

void setup() {                
Serial.begin(9600);     // inicializamos el puerto serie a 9600 baudios
pinMode(11, OUTPUT);    // Pin 11 conectar a IN4
pinMode(10, OUTPUT);    // Pin 10 conectar a IN3
pinMode(9, OUTPUT);     // Pin 9 conectar a IN2
pinMode(8, OUTPUT);     // Pin 8 conectar a IN1
pinMode(sensorLuz, INPUT);    
}

void loop() {
  while (Serial.available()) {    // Leer el valor enviado por el Puerto serial
    delay(retardo);
    char c  = Serial.read();     // Lee los caracteres
    leeCadena += c;              // Convierte Caracteres a cadena de caracteres
  }  
  if (leeCadena.length()>0){       
        dato_rx = leeCadena.toInt();   // Convierte Cadena de caracteres a Enteros
         //motorSpeed = leeCadena.toInt();
         Serial.print(dato_rx);         // Envia valor en Grados 
         Serial.println(" Grados");
         /*Serial.print(motorSpeed);
         Serial.println(" velocidad");  */       
        delay(retardo);
        dato_rx = (dato_rx * 1.4222222222); // Ajuste de 512 vueltas a los 360 grados
       // motorSpeed = (motorSpeed/15 + 5);
  } 
     /* if (leeCadena.length()>0){       
         motorSpeed = leeCadena.toInt();
         Serial.print(motorSpeed);
         Serial.println(" velocidad");
        delay(retardo);
        motorSpeed = (motorSpeed/15 + 5);
  } 
*/
   while (dato_rx>numero_pasos){   // Girohacia la izquierda en grados
       paso_izq();
       numero_pasos = numero_pasos + 1;
   }
   while (dato_rx<numero_pasos){   // Giro hacia la derecha en grados
        paso_der();
        numero_pasos = numero_pasos -1;
   }
   
  leeCadena = "";   // Inicializamos la cadena de caracteres recibidos 
  apagado();         // Apagado del Motor para que no se caliente



 potValue = analogRead(potPin); 
 //Serial.println(potValue);
   if (potValue < 1024){              
    motorSpeed = (potValue/15 + 1);
   }
 /* else {                             //value of the potentiometer is 512 - 1024
    motorSpeed = ((1024-potValue)/15 + 5); //scale potValue for motor speed
   
  }*/
}  ///////////////////// Fin del Loop ///////////////////////////

void paso_der(){         // Pasos a la derecha

   const int sensorLuz = A1;
  float luminosidad;

   luminosidad = analogRead(A1);
   luminosidad = (luminosidad * 100) / 1023;  
 digitalWrite(11, LOW); 
 digitalWrite(10, LOW);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, HIGH);  
 Serial.print(luminosidad);
 Serial.println("%");
   delay(motorSpeed); 
 digitalWrite(11, LOW); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, LOW);  
 Serial.print(luminosidad);
 Serial.println("%");
   delay(motorSpeed); 
 digitalWrite(11, HIGH); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, LOW);  
 digitalWrite(8, LOW);
 Serial.print(luminosidad);
 Serial.println("%");  
  delay(motorSpeed);  
 digitalWrite(11, HIGH); 
 digitalWrite(10, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(8, HIGH);
 Serial.print(luminosidad);
 Serial.println("%");   
  delay(motorSpeed);   
}

void paso_izq() {        // Pasos a la izquierda
   const int sensorLuz = A1;
  float luminosidad;

   luminosidad = analogRead(A1);
   luminosidad = (luminosidad * 100) / 1023;  
 digitalWrite(11, HIGH); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, LOW);  
 digitalWrite(8, LOW);
 Serial.print(luminosidad);
 Serial.println("%");   
  delay(motorSpeed); 
 digitalWrite(11, LOW); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, LOW); 
 Serial.print(luminosidad);
 Serial.println("%");  
  delay(motorSpeed);
 digitalWrite(11, LOW); 
 digitalWrite(10, LOW);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, HIGH);
 Serial.print(luminosidad);
 Serial.println("%");   
  delay(motorSpeed); 
 digitalWrite(11, HIGH); 
 digitalWrite(10, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(8, HIGH);
 Serial.print(luminosidad);
 Serial.println("%");   
  delay(motorSpeed); 
}
        
void apagado() {         // Apagado del Motor
 digitalWrite(11, LOW); 
 digitalWrite(10, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(8, LOW);  
 }
